package izayoi;

import java.io.IOException;
import java.util.Arrays;
import java.util.Collections;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletRequestWrapper;

/**
 * asciip[^̕ΏtB^(UTF-8x^ł)<br>
 * m[g⃊Xg̓eŕꍇɎg<br>
 * p̃Reił͑T̏Öق̂ɂĂ̂ŁA͗vȂ
 * (̂悤ȊłgƋtɉ)<br>
 * threadɂKpȂ(}`p[g̒œl̂Ƃs)
 * @author es
 */
public class EncodeFilter implements Filter {

    /* ( Javadoc)
     * @see javax.servlet.Filter#init(javax.servlet.FilterConfig)
     */
    public void init(FilterConfig arg0) throws ServletException {
    }

    /* ( Javadoc)
     * @see javax.servlet.Filter#doFilter(javax.servlet.ServletRequest, javax.servlet.ServletResponse, javax.servlet.FilterChain)
     */
    public void doFilter(ServletRequest arg0, ServletResponse arg1, FilterChain arg2)
        throws IOException, ServletException {
        HttpServletRequest req = (HttpServletRequest) arg0;
        Map m = new HashMap(req.getParameterMap());
        for (Iterator i = Arrays.asList(m.keySet().toArray()).iterator(); i.hasNext();) {
            String key = (String) i.next();
            Object data = m.get(key);
            if (data instanceof String[]) {
                String[] temp = (String[]) data;
                for (int j = 0; j < temp.length; j++) {
                    temp[j] = new String(temp[j].getBytes("ISO-8859-1"), "UTF-8");
                }
                m.put(key, temp);
            } else {
                data = new String[] { new String(((String) data).getBytes("ISO-8859-1"), "UTF-8")};
                m.put(key, data);
            }
        }
        req = new ModServletRequest(req);
        ((ModServletRequest)req).setRequestMap(m);
        arg2.doFilter(req, arg1);
    }

    /* ( Javadoc)
     * @see javax.servlet.Filter#destroy()
     */
    public void destroy() {
    }

}
class ModServletRequest extends HttpServletRequestWrapper {

    private Map reqMap;
    void setRequestMap(Map m) {
        reqMap = m;
    }

    /**
     * @param arg0
     */
    public ModServletRequest(HttpServletRequest arg0) {
        super(arg0);
    }

    /* ( Javadoc)
     * @see javax.servlet.ServletRequest#getParameter(java.lang.String)
     */
    public String getParameter(String arg0) {
        Object obj = reqMap.get(arg0);
        if (obj == null) {
            return null;
        } else {
            return ((String[]) obj)[0];
        }
    }

    /* ( Javadoc)
     * @see javax.servlet.ServletRequest#getParameterMap()
     */
    public Map getParameterMap() {
        return Collections.unmodifiableMap(reqMap);
    }

    /* ( Javadoc)
     * @see javax.servlet.ServletRequest#getParameterNames()
     */
    public Enumeration getParameterNames() {
        return new TinyEnumeration(reqMap.keySet());
    }

    /* ( Javadoc)
     * @see javax.servlet.ServletRequest#getParameterValues(java.lang.String)
     */
    public String[] getParameterValues(String arg0) {
        return (String[]) reqMap.get(arg0);
    }

    private class TinyEnumeration implements Enumeration {

        private Iterator i;

        /**
         * @param set
         */
        public TinyEnumeration(Set set) {
            i = set.iterator();
        }

        /* ( Javadoc)
         * @see java.util.Enumeration#hasMoreElements()
         */
        public boolean hasMoreElements() {
            return i.hasNext();
        }

        /* ( Javadoc)
         * @see java.util.Enumeration#nextElement()
         */
        public Object nextElement() {
            return i.next();
        }
    }
}
