package izayoi.cache;

import java.io.IOException;
import java.util.Comparator;

/**
 * CacheEntrỹ\[^
 * @author es
 */
public abstract class CacheEntrySorter implements Comparator {

    /**
     * R[hŃ\[g
     * @author es
     */
    public static class ByCount extends CacheEntrySorter {

        /* ( Javadoc)
         * @see izayoi.cache.CacheEntrySortor#compare(izayoi.cache.CacheEntry, izayoi.cache.CacheEntry)
         */
        protected int compare(CacheEntry arg0, CacheEntry arg1) {
            try {
                long a0 = arg0.getCount();
                long a1 = arg1.getCount();
                if (a0 == a1) {
                    return 0;
                } else {
                    return a0 > a1 ? 1 : -1;
                }
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
    }

    /**
     * ŏIXVŃ\[g
     * @author es
     */
    public static class ByLastMod extends CacheEntrySorter {

        /* ( Javadoc)
         * @see izayoi.cache.CacheEntrySortor#compare(izayoi.cache.CacheEntry, izayoi.cache.CacheEntry)
         */
        protected int compare(CacheEntry arg0, CacheEntry arg1) {
            try {
                long a0 = arg0.getLastModified();
                long a1 = arg1.getLastModified();
                if (a0 == a1) {
                    return 0;
                } else {
                    return a0 > a1 ? 1 : -1;
                }
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
    }

    /**
     * x[Xl[Ń\[g
     * @author es
     */
    public static class ByName extends CacheEntrySorter {

        /* ( Javadoc)
         * @see izayoi.cache.CacheEntrySortor#compare(izayoi.cache.CacheEntry, izayoi.cache.CacheEntry)
         */
        protected int compare(CacheEntry arg0, CacheEntry arg1) {
            return arg0.getBaseName().compareTo(arg1.getBaseName());
        }
    }

    /**
     * t@CTCYŃ\[g
     * @author es
     */
    public static class BySize extends CacheEntrySorter {

        /* ( Javadoc)
         * @see izayoi.cache.CacheEntrySortor#compare(izayoi.cache.CacheEntry, izayoi.cache.CacheEntry)
         */
        protected int compare(CacheEntry arg0, CacheEntry arg1) {
            try {
                long a0 = arg0.getSize();
                long a1 = arg1.getSize();
                if (a0 == a1) {
                    return 0;
                } else {
                    return a0 > a1 ? 1 : -1;
                }
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
    }

    //-------------------------------------------------------------------

    private boolean isAsc = true;

    /**
     * r
     * @param arg0 vfA
     * @param arg1 vfB
     * @return java.util.Comparator#compareƓ
     * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
     */
    protected abstract int compare(CacheEntry arg0, CacheEntry arg1);

    /* ( Javadoc)
     * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
     */
    public final int compare(Object arg0, Object arg1) {
        return isAsc ? compare((CacheEntry) arg0, (CacheEntry) arg1) : compare((CacheEntry) arg1, (CacheEntry) arg0);
    }

    /**
     * /~̎w
     * @param b ^ŏ/Uō~
     */
    public final void setOrder(boolean b) {
        isAsc = b;
    }
}
