/**
 * NegateResponse.java
 * Created on 2005/05/20
 * Copyright (c) by es , All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND 
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED 
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package izayoi.node;


import java.text.MessageFormat;

/**
 * TalkingQuerys̔ے艞
 * @author es
 */
public class NegateResponse extends Throwable {

    //@TODO \[X
    private static final String neg = "R}h {0} ɂĔے艞󂯎܂.";
    private static final String exp = "R}h {0} ɂĎ̗O܂ [{1}]";

    private TalkingQuery q;

    private NegateResponse(String s) {
        super(s);
    }

    /**
     * Oɂے艞
     * @param query NTalkingQuery
     * @param ex O
     */
    public NegateResponse(TalkingQuery query, Throwable ex) {
        this(MessageFormat.format(exp, new Object[] { query.getCommand(), ex.getMessage()}));
        this.q = query;
        initCause(ex);
    }

    /**
     * ʏ̔ے艞
     * @param query NTalkingQuery
     */
    public NegateResponse(TalkingQuery query) {
        this(MessageFormat.format(neg, new Object[] { query.getCommand()}));
        this.q = query;
    }

    /**
     * NTalkingQuery擾
     * @return
     */
    public TalkingQuery getQuery() {
        return q;
    }
}
