/**
 * ViewNote.java
 * Created on 2005/06/08
 * Copyright (c) by es , All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND 
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED 
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package izayoi.view;

import java.text.SimpleDateFormat;
import java.util.Date;

import izayoi.Constants;
import izayoi.cache.Record;

/**
 * noteñev[gɗRei
 * @author es
 */
public class ViewNote implements DataContainer  {

    private Date date;
    private String id;
    private long time;
    private String key;
    private String body;

    /**
     * 
     */
    public ViewNote(Record record) {
        id = record.getID();
        time = record.getTimeStamp();
        date = new Date(time * 1000);
        key = id.substring(0, 8);
        body = record.containsField(Constants.FIELD_NAME_BODY) ? record.getField(Constants.FIELD_NAME_BODY) : "";
    }

    /**
     * @return
     */
    public String getBody() {
        return body;
    }

    /**
     * @return
     */
    public String getDate() {
        return SimpleDateFormat.getDateTimeInstance().format(date);
    }

    /**
     * @return
     */
    public String getId() {
        return id;
    }

    /**
     * @return
     */
    public String getKey() {
        return key;
    }

    /**
     * @return
     */
    public long getTime() {
        return time;
    }

}
