package net.prixdami.alexis.multipart;

import java.io.IOException;
import java.io.InputStream;

class MultipartInputStream extends InputStream {

    private InputStream _in;

    /**
     * @param in
     */
    public MultipartInputStream(InputStream in) {
        _in = in;
    }

    /* ( Javadoc)
     * @see java.io.InputStream#read()
     */
    public int read() throws java.io.IOException {
        return _in.read();
    }

    /* ( Javadoc)
     * @see java.io.InputStream#read(byte[])
     */
    public int read(byte[] b) throws java.io.IOException {
        return _in.read(b);
    }

    /* ( Javadoc)
     * @see java.io.InputStream#read(byte[], int, int)
     */
    public int read(byte[] b, int off, int len) throws java.io.IOException {
        return _in.read(b, off, len);
    }

    /**
     * @param b
     * @param off
     * @param len
     * @return
     * @throws IOException
     */
    public int readLine(byte[] b, int off, int len) throws IOException {
        if (len <= 0) {
            return 0;
        }
        int count = 0;
        int i;
        while ((i = read()) != -1) {
            b[off++] = (byte) i;
            count++;
            if (i == 10 || count == len) {
                break;
            }
        }

        return count <= 0 ? -1 : count;
    }

    /* ( Javadoc)
     * @see java.io.InputStream#close()
     */
    public void close() throws java.io.IOException {
        _in.close();
    }

}