package net.prixdami.alexis.multipart;

import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletRequestWrapper;

class SneakMultipartRequest extends HttpServletRequestWrapper {

    private Map param;

    /**
     * @param arg0
     */
    public SneakMultipartRequest(HttpServletRequest arg0) {
        super(arg0);
        param = new HashMap(arg0.getParameterMap());
    }

    public void setParameter(String name, String[] values) {
        if (param.containsKey(name)) {
            List l = new ArrayList(Arrays.asList(getParameterValues(name)));
            l.addAll(Arrays.asList(values));
            values = new String[l.size()];
            l.toArray(values);
        }
        param.put(name, values);
    }

    /* ( Javadoc)
     * @see javax.servlet.ServletRequest#getParameter(java.lang.String)
     */
    public String getParameter(String arg0) {
        return param.containsKey(arg0) ? getParameterValues(arg0)[0] : null;
    }

    /* ( Javadoc)
     * @see javax.servlet.ServletRequest#getParameterMap()
     */
    public Map getParameterMap() {
        return param;
    }

    /* ( Javadoc)
     * @see javax.servlet.ServletRequest#getParameterNames()
     */
    public Enumeration getParameterNames() {
        return new TinyEnumeration(param.keySet().iterator());
    }

    /* ( Javadoc)
     * @see javax.servlet.ServletRequest#getParameterValues(java.lang.String)
     */
    public String[] getParameterValues(String arg0) {
        return (String[]) param.get(arg0);
    }

    private class TinyEnumeration implements Enumeration {
        private Iterator _i;
        public TinyEnumeration(Iterator i) {
            _i = i;
        }
        public boolean hasMoreElements() {
            return _i.hasNext();
        }
        public Object nextElement() {
            return _i.next();
        }
    }

}
